'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReactDOMInjectProvider = exports.connect = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _ReactDOMInject = require('./ReactDOMInject');

var _ReactDOMInject2 = _interopRequireDefault(_ReactDOMInject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Used just like react-redux connect.
 */
var connect = exports.connect = function connect(mapStateToProps, mapDispatchToProps, mergeProps, options) {
  return function (ReactElement) {
    return function (store) {
      var InjectProvider = ReactDOMInjectProvider(ReactElement)(store);
      return (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps, options)(InjectProvider);
    };
  };
};

/**
 * Wraps ReactDOMInject with a thunk to inject the store.
 */
var ReactDOMInjectProvider = exports.ReactDOMInjectProvider = function ReactDOMInjectProvider(ReactElement) {
  return function (store) {
    var ReactElementProvider = function ReactElementProvider(props) {
      return _react2.default.createElement(
        _reactRedux.Provider,
        { store: store },
        _react2.default.createElement(ReactElement, props)
      );
    };
    return (0, _ReactDOMInject2.default)(ReactElementProvider);
  };
};